
/* compile.c */
static object *code_getattr ( codeobject *co , char *name );
static void code_dealloc ( codeobject *co );
static object *code_repr ( codeobject *co );
static int code_compare ( codeobject *co , codeobject *cp );
static long code_hash ( codeobject *co );
static void com_error ( struct compiling *c , object *exc , char *msg );
static void block_push ( struct compiling *c , int type );
static void block_pop ( struct compiling *c , int type );
static int com_init ( struct compiling *c , char *filename );
static void com_free ( struct compiling *c );
static void com_done ( struct compiling *c );
static void com_addbyte ( struct compiling *c , int byte );
static void com_addint ( struct compiling *c , int x );
static void com_addoparg ( struct compiling *c , int op , int arg );
static void com_addfwref ( struct compiling *c , int op , int *p_anchor );
static void com_backpatch ( struct compiling *c , int anchor );
static int com_add ( struct compiling *c , object *list , object *v );
static int com_addconst ( struct compiling *c , object *v );
static int com_addname ( struct compiling *c , object *v );
static int com_mangle ( struct compiling *c , char *name , char *buffer , int maxlen );
static void com_addopnamestr ( struct compiling *c , int op , char *name );
static void com_addopname ( struct compiling *c , int op , node *n );
static object *parsenumber ( struct compiling *co , char *s );
static object *parsestr ( char *s );
static object *parsestrplus ( node *n );
static void com_list_constructor ( struct compiling *c , node *n );
static void com_dictmaker ( struct compiling *c , node *n );
static void com_atom ( struct compiling *c , node *n );
static void com_slice ( struct compiling *c , node *n , int op );
static int com_argument ( struct compiling *c , node *n , int inkeywords );
static void com_call_function ( struct compiling *c , node *n );
static void com_select_member ( struct compiling *c , node *n );
static void com_sliceobj ( struct compiling *c , node *n );
static void com_subscript ( struct compiling *c , node *n );
static void com_subscriptlist ( struct compiling *c , node *n , int assigning );
static void com_apply_trailer ( struct compiling *c , node *n );
static void com_power ( struct compiling *c , node *n );
static void com_factor ( struct compiling *c , node *n );
static void com_term ( struct compiling *c , node *n );
static void com_arith_expr ( struct compiling *c , node *n );
static void com_shift_expr ( struct compiling *c , node *n );
static void com_and_expr ( struct compiling *c , node *n );
static void com_xor_expr ( struct compiling *c , node *n );
static void com_expr ( struct compiling *c , node *n );
static enum cmp_op cmp_type ( node *n );
static void com_comparison ( struct compiling *c , node *n );
static void com_not_test ( struct compiling *c , node *n );
static void com_and_test ( struct compiling *c , node *n );
static void com_test ( struct compiling *c , node *n );
static void com_list ( struct compiling *c , node *n , int toplevel );
static void com_assign_attr ( struct compiling *c , node *n , int assigning );
static void com_assign_trailer ( struct compiling *c , node *n , int assigning );
static void com_assign_tuple ( struct compiling *c , node *n , int assigning );
static void com_assign_list ( struct compiling *c , node *n , int assigning );
static void com_assign_name ( struct compiling *c , node *n , int assigning );
static void com_assign ( struct compiling *c , node *n , int assigning );
static void com_expr_stmt ( struct compiling *c , node *n );
static void com_print_stmt ( struct compiling *c , node *n );
static void com_return_stmt ( struct compiling *c , node *n );
static void com_raise_stmt ( struct compiling *c , node *n );
static void com_import_stmt ( struct compiling *c , node *n );
static void com_global_stmt ( struct compiling *c , node *n );
static int com_newlocal_o ( struct compiling *c , object *nameval );
static int com_addlocal_o ( struct compiling *c , object *nameval );
static int com_newlocal ( struct compiling *c , char *name );
static void com_exec_stmt ( struct compiling *c , node *n );
static void com_if_stmt ( struct compiling *c , node *n );
static void com_while_stmt ( struct compiling *c , node *n );
static void com_for_stmt ( struct compiling *c , node *n );
static void com_try_except ( struct compiling *c , node *n );
static void com_try_finally ( struct compiling *c , node *n );
static void com_try_stmt ( struct compiling *c , node *n );
static object *get_docstring ( node *n );
static void com_suite ( struct compiling *c , node *n );
static void com_continue_stmt ( struct compiling *c , node *n );
static int com_argdefs ( struct compiling *c , node *n );
static void com_funcdef ( struct compiling *c , node *n );
static void com_bases ( struct compiling *c , node *n );
static void com_classdef ( struct compiling *c , node *n );
static void com_node ( struct compiling *c , node *n );
static void com_fpdef ( struct compiling *c , node *n );
static void com_fplist ( struct compiling *c , node *n );
static void com_arglist ( struct compiling *c , node *n );
static void com_file_input ( struct compiling *c , node *n );
static void compile_funcdef ( struct compiling *c , node *n );
static void compile_lambdef ( struct compiling *c , node *n );
static void compile_classdef ( struct compiling *c , node *n );
static void compile_node ( struct compiling *c , node *n );
static void optimize ( struct compiling *c );
static codeobject *icompile ( node *n , struct compiling *base );
static codeobject *jcompile ( node *n , char *filename , struct compiling *base );
